<?php

affiliate_pages_pro_use([
	'Controllers/Admin/AdminController'
]);

class AffiliatePagesPro_AdminWindowController extends AffiliatePagesPro_AdminController
{

	protected $cdn = [
    'css' => [
      'https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900',
      'https://fonts.googleapis.com/css?family=Material+Icons',
      'https://use.fontawesome.com/releases/v5.6.0/css/all.css',
      'https://cdn.plyr.io/3.5.2/plyr.css'
    ],
    'js' => [
      'https://cdn.plyr.io/3.5.2/plyr.polyfilled.js'
    ]
  ];

	public function index($request)
	{
		if(is_user_logged_in()) {
			if(current_user_can('administrator')) {
				$data = $this->getData($request->token);
				// wp_send_json($data); exit;
				$this->view('admin.window', ['package' => 'client', 'data' => $data, 'cdn' => $this->cdn]);
				exit;
			}
		}
	}

	private function getData($token) {

		return [
			'token' => $token,
			'api' => $this->route('/api'),
			'siteurl' => get_site_url()
		];
		// data-api="http://localhost:8888/instantaffiliatepages/affiliate-pages-pro/api"
		//
		//
		// data-token="15cdd139b10051nnfcymdo2kvhpqztmimd7jujkhcxjcqes6lnelygeszosvpqmx-1"
		// data-siteurl="http://localhost:8888/instantaffiliatepages"
	}
}
