<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController',
	'Controllers/Api/Settings/ApiSettingsController',
	'Helpers/Client',
	'Helpers/WP/GetMenu'
]);


class AffiliatePagesPro_ApiAdminController extends AffiliatePagesPro_ApiController
{
	use AffiliatePagesPro_Client,
	AffiliatePagesPro_WPGetMenu;

	public function menu($request)
	{
		$menu = $this->wpGetMenu($request->menu);
		wp_send_json($menu); exit;
	}

	public function index($request)
	{

		$settings = new AffiliatePagesPro_ApiSettingsController;

		$lic = $this->getOption('lic');

		$lic['valid'] = $this->isLicValid($lic);

		$data = [
			'title' => self::$plugin_app_name,
			'cl' => self::$plugin_app_cl,
			'lic' => $lic,
			'settings' => $settings->getSettings(),
			'menus' => get_terms('nav_menu')
		];

		wp_send_json([
			'valid' =>  $lic['valid'],
			'data' => $data
		]); exit;
    // if(empty($lic)) {
		// 	$response['success'] = false;
		// 	$response['data'] = 'To activate or update your license, please enter your registred email and password and click update.';
    // } else {
		// 	$response['success'] = true;
		// 	$response['data'] = $lic;
		// }
		//
		// // hide if branded
		// $response['app']['brandable'] = $this->hasAddon('dev');
		//
		// $o = self::$options;
		//
		// if(!empty($response['app']['brandable']) && !empty(self::$options) && !empty(self::$options['b_active'])) {
		// 	if(!empty(self::$options['b_title'])) {
		// 		$response['app']['title'] = self::$options['b_title'];
		// 	}
		// 	if(!empty(self::$options['b_logo'])) {
		// 		$response['app']['logo'] = self::$options['b_logo'];
		// 	}
		// }
		//
		// if(empty($o) || empty($o['hide_se']) || empty($o['master_user']) || $o['master_user'] == $request->user_id) {
		//
		// } else {
		// 	$response['app']['hide_settings'] = true;
		// }

		// append settings


		// $response['settings'] = $settings->getSettings();

		wp_send_json($response); exit;

	}

	private function isLicValid($lic)
	{
		foreach(['product', 'access', 'valid'] as $i) {
			if(empty($lic[$i])) {
				return false;
			}
			$lic = $lic[$i];
		}
		return $lic;
	}

}
