<?php

affiliate_pages_pro_use([
'Controllers/Api/ApiController',
'DataTables/PageDataTable',
'Models/Block',
'Models/Page',
]);

class AffiliatePagesPro_ApiPageBlocksController extends AffiliatePagesPro_ApiController
{
  public function index($request)
  {
    // get page and all components
    $blocks = AffiliatePagesPro_Block::where('page_id',$request->id)->orderBy('sort', 'asc')->get();

    // $blocks = AffiliatePagesPro_Block::all();

    // blocks
    // $blocks = $this->getBlockTypes($blocks);


    wp_send_json($blocks);
  }

  public function update($request)
  {

    // save page
    $page = new AffiliatePagesPro_PageDataTable;

    $page->update($request);

    wp_send_json_success();

    // save blocks

  }

  private function getBlockTypes($blocks)
  {

    if(empty($blocks)) {
      return $blocks;
    }

    $count = 0;
    foreach($blocks as $block) {

      if($block->block_type == 'video') {
        $blocks[$count]->video = AffiliatePagesPro_Video::find($block->type_id);
      }
      if($block->block_type == 'bonus') {
        $blocks[$count]->bonus = AffiliatePagesPro_Bonus::find($block->type_id);
      }

      $count++;
    }

    return $blocks;
  }
}
