<?php

affiliate_pages_pro_use([
  'Controllers/Controller',
  'Models/Page',
  'Models/Block',
  'Models/Split',
]);


class AffiliatePagesPro_PageDownloadController extends AffiliatePagesPro_Controller
{
  public function index($request)
  {

    $block = AffiliatePagesPro_Block::where('identifier', $request->identifier)->first(['source', 'page_id']);

    if(empty($block->source)) {
      return;
    }

    $page = AffiliatePagesPro_Page::find($block->page_id, ['id', 'affiliate_link', 'title', 'is_active']);

    if(empty($page)) {
      return;
    }


    $visit = AffiliatePagesPro_Visit::where('identifier', $request->visit)->first();

    // if expire stats
    if(empty($visit) || current_time('U') > $visit->created_ts + 86400) {
      return;
    }

    wp_redirect($block->source); exit;

  }
}
