<?php


affiliate_pages_pro_use([
	'Controllers/Controller',
	'Models/Stat',
	'Models/Visit',
	'Models/Click',
	'Models/Page',
	'Core/Seeder',
	// '../database/seed/Video'
]);

class AffiliatePagesPro_TestController extends AffiliatePagesPro_Seeder
{

	public function index($request)
	{
		return;
		$seeder = new AffiliatePagesPro_Seeder;
		// $seeder->setModel('Stat');

		$seeder->fields([
			'page_id' => '16',
			// 'is_visit' => 1,

			'is_unique' => ['SOMETIMES', 1, 60],
			// 'clicked' => ['SOMETIMES', 1, 35],
			'created' => ['BDATE', 0, 30, 'days'],
			'created_ts' => ['BDATE', 0, 30, 'days', 'u']
			// ['ONEOF', ['fields' => ['is_click','is_conversion'], 'value' => 1]],
			// ['SOMETIMES', [1, 60]],
			// ['SOMETIMES', ['is_click', 1, 35]],
			// ['BDATE', ['created', 0, 30, 'days']],
			// ['BDATE', ['created_ts', 0, 30, 'days', 'u']],
		]);

		$data = $seeder->run(10000, 'Visit');

		// clicks
			$data = $seeder->run(4000, 'Click');
		exit;
	}


	public function indexx($request)
	{
		echo 'test'; exit;

		return;
		$this->video = AffiliatePagesPro_Video::find($request->id);

		// wp_send_json($video); exit;
		// $this->start('Stat');
		// exit;
		$this->fields([
			'video_id' => $this->video->id,
			'client_ip' => 'IP',
			'loaded' => 1,
			'created_ts' => 100,
			['BDATE', ['created', 0, 30, 'days']],
			['BDATE', ['created_ts', 0, 30, 'days', 'u']],
			['BETWEEN', ['progress', 10, 100]],
			['ONEOF', ['fields' => ['loaded','played', 'clicked', 'ended', 'forwarded'], 'value' => 1]]
		]);

		$data = $this->run(1000, 'Stat', 'onStatsPrep', 'onStatCreated');

		wp_send_json($data);


	}

	public function onStatsPrep($item)
	{
		if(!empty($item->clicked) || !empty($item->forwarded)) {
			$item->played = 1;
		}
		if(!empty($item->clicked) || !empty($item->forwarded)) {
			$item->converted = 1;
		}
		return $item;

	}

	public function onStatCreated($item)
	{


		$fields = [
				'video_id' => $item->video_id,
				'stat_id' => $item->id,
				'is_unique' => 1,
				['BDATE', ['created', 0, 30, 'days']],
				['BDATE', ['created_ts', 0, 30, 'days', 'u']],
			];

			$this->video->addCount('load');

			// always play
			if(!empty($item->clicked) || !empty($item->forwarded) || !empty($item->played)) {
				$seeder = new AffiliatePagesPro_Seeder;
				$seeder->fields($fields);
				$seeder->run(1, 'Play');
				$this->video->addCount('play');
			}


			// get conversions
			if(!empty($item->clicked) || !empty($item->forwarded)) {

				$this->video->addCount('conversion');

				$seeder = new AffiliatePagesPro_Seeder;
				// $seeder = new AffiliatePagesPro_Seeder('Conversion');

				if(!empty($item->clicked)) {
					$fields['is_click'] = 1;
					$this->video->addCount('click');
				}
				elseif(!empty($item->forwarded)) {
					$fields['is_forward'] = 1;
					$fields['is_ended'] = 1;
					$this->video->addCount(['ended', 'forward']);
				}
				else { // ended only other choice
					$fields['is_ended'] = 1;
					$this->video->addCount('ended');
				}

				$seeder->fields($fields);
				$seeder->run(1, 'Conversion');

			}

			$this->video->save();

			return $item;

	}

	public function addPlayed($statId)
	{

	}


	// public function onItemCreated($item, $video) {
	//
	// 	$fields = [
	// 		'video_id' => $item->video_id,
	// 		'stat_id' => $item->id,
	// 		'is_unique' => 1,
	// 		['BDATE', ['created', 0, 30, 'days']],
	// 		['BDATE', ['created_ts', 0, 30, 'days', 'u']],
	// 	];
	//
	// 	$video->addCount('load');
	//
	// 	// always play
	// 	if(!empty($item->clicked) || !empty($item->forwarded) || empty($item->played)) {
	// 		$seeder = new AffiliatePagesPro_Seeder('Play');
	// 		$seeder->fields($fields);
	// 		$seeder->run(1);
	// 		$video->addCount('play');
	// 	}
	//
	//
	// 	// get conversions
	// 	if(!empty($item->clicked) || !empty($item->forwarded)) {
	//
	// 		$video->addCount('conversion');
	//
	// 		$seeder = new AffiliatePagesPro_Seeder('Conversion');
	//
	// 		if(!empty($item->clicked)) {
	// 			$fields['is_click'] = 1;
	// 			$video->addCount('click');
	// 		}
	// 		elseif(!empty($item->forwarded)) {
	// 			$fields['is_forward'] = 1;
	// 			$fields['is_ended'] = 1;
	// 			$video->addCount(['ended', 'forward']);
	// 		}
	// 		else { // ended only other choice
	// 			$fields['is_ended'] = 1;
	// 			$video->addCount('ended');
	// 		}
	//
	// 		$seeder->fields($fields);
	// 		$seeder->run(1);
	//
	// 	}
	//
	// 	$video->save();
	//
	// 	return $item;
	// }







		private function getStatsId($videoId)
		{
			$clientIp = affiliate_pages_pro_get_client_ip();

			$stat = new AffiliatePagesPro_Stat;
			$embedId = $stat->getEmbedId($videoId, $clientIp);

			wp_send_json([$embedId, $stat]); exit;

			// create embed id, save load
			$stat = AffiliatePagesPro_Stat::where('client_ip', $clientIp)
																			->andWhere('video_id', $videoId)
																			// add unique cut off
																			->first();


			if(empty($stat)) {
				$stat = new AffiliatePagesPro_Stat;
				$stat->client_ip = $clientIp;
				$stat->video_id = $videoId;
				// created_ts
				$stat->save();
			}

			return $stat->identifier;

		}

}
