<?php

if(trait_exists('AffiliatePagesPro_DataTableDublicate')) {
    return;
}

trait AffiliatePagesPro_DataTableDublicate
{
  protected $dublicate_ignore_request_fields = [
    'auth_token',
    'get_data',
    'id'
  ];

  // filter on dublicate complete, not returning anything
    public function dublicatedFilter($item, $orig)
    {}

    public function dublicate($request, $returnItem=false)
    {
      // append to item
      $item = $this->showGetItem($request);

      $fields = $this->getUpdateFields();

      foreach($fields as $field) {
        if(isset($item->{$field}) && !in_array($field, $this->dublicate_ignore_fields)) {
          $request->{$field} = $item->{$field};
        }
      }

      // foreach($item as $key => $value) {
      //   if(!in_array($key, $this->dublicate_ignore_fields)) {
      //     $request->{$key} = $value;
      //   }
      // }

      if(!empty($request->title) && !empty($this->dublicate_copy_append_text)) {
        $request->title .= $this->dublicate_copy_append_text;
      }
      elseif(!empty($request->name) && !empty($this->dublicate_copy_append_text)) {
        $request->name .= $this->dublicate_copy_append_text;
      }

      // unset ignores
      if(!empty($this->dublicate_ignore_request_fields)) {
        foreach($this->dublicate_ignore_request_fields as $i) {
          if(isset($request->{$i})) {
            unset($request->{$i});
          }
        }
      }

      $newItem = $this->create($request, true, true);

      $this->dublicatedFilter($newItem, $item);

      if($returnItem) {
        return $newItem;
      }

      wp_send_json($newItem); exit;
    }

}
