<?php

if(trait_exists('AffiliatePagesPro_DataTableShow')) {
    return;
}

trait AffiliatePagesPro_DataTableShow
{
  public function showGetItem($request)
  {
    if(!empty($this->use_db_user_id)) {
      $item = $this->builder->_where('id', $request->id)->andWhere('user_id', $request->user_id)->first();
    } else {
      $item = $this->builder->find($request->id);
    }

    if(empty($item)) {
      wp_send_json_error('not_found'); exit;
    }
    return $item;

  }

    public function show($request)
    {

      $this->request = $request;

        $item = $this->showGetItem($request);

        $fields = $this->getItemFields();

        if($this->strip_slashes) {
            foreach($fields as $i) {
                if(!empty($item->{$i})) {
                    $item->{$i} = str_replace('\\','',$item->{$i});
                }
            }
        }

        $item = $this->showFilter($item);

        if(!empty($this->parse_numbers) && !empty($item)) {
          $item = $this->parseItemNumbers($item);
        }

        wp_send_json($item);
    }



    public function showFilter($item) {
        return $item;
    }
}
