<?php

if(trait_exists('AffiliatePagesPro_ModelFirstOrCreate')) {
    return;
}

trait AffiliatePagesPro_ModelFirstOrCreate
{

	public static function firstOrUpdate($match, $args=[], $cols='*')
	{
		return (new static)->firstOrCreateNew($match, $args, $cols, true);
	}

	public static function firstOrCreate($match, $args=[], $cols='*', $update=false)
	{
		return (new static)->firstOrCreateNew($match, $args, $cols, $update);
	}

	private function firstOrCreateNew($match, $args=[], $cols='*', $update=false)
	{

		global $wpdb;

		$query = "SELECT {$cols} FROM {$this->getTableFullName()}";

		$count = 0;

		foreach ($match as $key => $value) {

			$this->{$key} = $value;

      $compare = '=';

			if($count < 1) {

				$query .= " WHERE {$key} {$compare} '{$value}'";

			} else {
				$query .= " AND {$key} {$compare} '{$value}'";
			}
			$count++;

		}

		$query .= " LIMIT 1";

		$item = $wpdb->get_row($query);

		if(!empty($item)) {

			// add to self
			foreach($item as $key => $value) {
				$this->{$key} = $value;
			}

			// update, used in firstOrUpdate
			if($update && !empty($args)) {

				foreach ($args as $key => $value) {
					$this->{$key} = $value;
				}

				$this->save();
			}

			$this->updated = true;

			return $this;
		}

		// not found create it

		// append args
		if(!empty($args)) {
			foreach ($args as $key => $value) {
				$this->{$key} = $value;
			}
		}

		$this->save();

		$this->created = true;

		return $this;

	}

}
