<?php

trait AffiliatePagesPro_ModelLeftJoinAppend
{
  protected function leftJoinAppendGroup()
  {

    $table = $this->getTableFullName();

    // normal columns
    $columns = '';

    if(strstr($this->query_columns,'*') == true) {
      $query = "SELECT {$table}.{$this->query_columns}";
      $columns .= "{$table}.{$this->query_columns}";
    } else {
      $query = "SELECT {$this->query_columns}";
      $columns .= "{$this->query_columns}";
    }

    // $columns
    $LEFTJOIN = '';
    // joins
    foreach($this->query_leftjoin_group as $leftJoin)
    {

      $joinTable = $this->getTableFullName($leftJoin['table']);

      // wp_send_json($)

      $idCol = $leftJoin['id'];

      if(empty($leftJoin['cols'])) {
        $columns .= ", {$joinTable}.*";
        //$query .= ", {$joinTable}.*";
      }
      else {
        // custom cols with prefix
        $prefix = '';
        if(!empty($leftJoin['prefix'])) {
          $prefix = $leftJoin['prefix'];
        }
        foreach($leftJoin['cols'] as $col) {
          if(is_array($col)) {
            $columns .= ", {$joinTable}.".key($col)." as ".$col[key($col)];
          } else {
            $columns .= ", {$joinTable}.{$col} as {$prefix}{$col}";
          }
        }
      }


      // added
      if(!empty($leftJoin['left_id'])) {
        $left_id = $leftJoin['left_id'];
      } else {
        $left_id = 'id';
      }
      $LEFTJOIN .= " LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.{$left_id}";

      // $LEFTJOIN .= " LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.id";


    }

    // echo $LEFTJOIN; exit;

    // WORKS
    /*
        $query = 'SELECT * FROM wp_mlewp1118_comments
    LEFT JOIN wp_mlewp1118_webinars ON wp_mlewp1118_comments.webinar_id = wp_mlewp1118_webinars.id
    LEFT JOIN wp_mlewp1118_contacts ON wp_mlewp1118_comments.contact_id = wp_mlewp1118_contacts.id';
    */

    $query = "SELECT {$columns} FROM {$table} {$LEFTJOIN}";

    // echo $query; exit;

    return $query;
    // $query .= " FROM {$table} LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.id";

    //wp_send_json($this->query_leftjoin_group); exit;


    // LEFT JOINS DONE
  }















  protected function leftJoinAppend()
  {
    return $this->leftJoinAppendGroup();

    // wp_send_json($this->query_leftjoin); exit;

    $table = $this->getTableFullName();
    $joinTable = $this->getTableFullName($this->query_leftjoin['table']);
    $idCol = $this->query_leftjoin['id'];

    if(strstr($this->query_columns,'*') == true) {
      $query = "SELECT {$table}.{$this->query_columns}";
    } else {
      $query = "SELECT {$this->query_columns}";
    }


    if(empty($this->query_leftjoin['cols'])) {
      $query .= ", {$joinTable}.*";
    }
    else {
      // custom cols with prefix
      $prefix = '';
      if(!empty($this->query_leftjoin['prefix'])) {
        $prefix = $this->query_leftjoin['prefix'];
      }
      foreach($this->query_leftjoin['cols'] as $col) {
        if(is_array($col)) {
          $query .= ", {$joinTable}.".key($col)." as ".$col[key($col)];
        } else {
          $query .= ", {$joinTable}.{$col} as {$prefix}{$col}";
        }
      }
    }

    // if(!empty($this->query_leftjoin['inverse'])) {
    //   $query .= " FROM {$table} LEFT JOIN {$joinTable} ON {$table}.id = {$joinTable}.{$idCol}";
    // } else {
    //   $query .= " FROM {$table} LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.id";
    // }
    // if(empty($this->leftjoins)) {
    //   $this->leftjoins = [];
    // }
    $query .= " FROM {$table} LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.id";
/*
    $query = 'SELECT * FROM wp_mlewp1118_comments
LEFT JOIN wp_mlewp1118_webinars ON wp_mlewp1118_comments.webinar_id = wp_mlewp1118_webinars.id
LEFT JOIN wp_mlewp1118_contacts ON wp_mlewp1118_comments.contact_id = wp_mlewp1118_contacts.id';
*/
    // echo $query; exit;
    return $query;
  }

  public function leftJoin($args, $cols=null, $prefix='') // MATCHID
  {
    // wp_send_json($cols); exit;

    if(is_array($args)) {
      $this->query_leftjoin = $args;
    }
    else {
      $this->query_leftjoin = [
        'table' => $args.'s',
        'id' => $args.'_id'
      ];
      if(!empty($prefix) && $prefix == 'MATCHID') {
        $this->query_leftjoin['prefix'] = $args.'_';
      }
    }

    if(!empty($cols)) {
      $this->query_leftjoin['cols'] = $cols;
    }

    if(!empty($prefix) && empty($this->query_leftjoin['prefix'])) {
      if($prefix == 'MATCHID') {
        $part = explode('_', $this->query_leftjoin['id']);
        array_pop($part);
        $this->query_leftjoin['prefix'] = implode('_',$part).'_';
      } else {
        $this->query_leftjoin['prefix'] = $prefix;
      }
    }

    if(empty($this->query_leftjoin_group)) {
      $this->query_leftjoin_group = [];
    }

    // wp_send_json($this->query_leftjoin); exit;

    array_push($this->query_leftjoin_group, $this->query_leftjoin);

    // echo 2;
   // echo 'add left join, ';
    //
    // wp_send_json($this->query_leftjoin_group); exit;
    // $this->query_leftjoin['inverse'] = true;
  // wp_send_json($this->query_leftjoin); exit;

    return $this;
  }

}
