<?php

class AffiliatePagesPro_Seeder extends AffiliatePagesPro
{
  protected $model;

  protected $fields;

  protected $item_callbacks = [];

  protected $item_created_callbacks = [];

  protected $item_funcs  = ['IP'];

  // public function __construct($model)
  // {
  //   $name = self::getPrefix().$model;
  //
  //   $this->model = self::getPrefix().$model;
  //
  // }

  public function setModel($model)
  {
    $name = self::getPrefix().$model;

    $this->model = self::getPrefix().$model;

  }

  // public function set

  public function fields($fields)
  {
    $this->fields = $fields;
  }

  public function onItemCallback($args)
  {
    array_push($this->item_callbacks, $args);
  }

  public function onItemCreated($args)
  {
    array_push($this->item_created_callbacks, $args);
  }


  public function run($itemsCount=50, $model=null, $beforeItemCreated=false, $afterItemCreated=false) {

    if(!empty($model)) {
      $this->setModel($model);
    }

    $items = [];
    $iCount = 0;
    while($iCount < $itemsCount) {

      // echo 'Start: '.$iCount.' '.$itemsCount;

        $item = new $this->model();

        // wp_send_json($this->fields); exit;

        foreach($this->fields as $key => $value) {



          if(is_array($value)) {

            // $item = $this->runFunc($value[0], $item, $value[1]);
          $val = $this->runFunc($value);
          if(!is_null($val)) {
            $item->{$key} = $val;
          }
          // wp_send_json([$key, $item, $value]); exit;

          }
          elseif(in_array($value, $this->item_funcs)) {
            $item->{$key} = $this->$value();
          }
          elseif(in_array($key, $this->item_funcs)) {
            $func = $value[0];
            $vals = $value[1];
            $item = $this->$func($item, $vals);

          }
          else {
            $item->{$key} = $value;



          }
        }

        // wp_send_json($item); exit;


        if(!empty($beforeItemCreated)) {
          $item = $this->$beforeItemCreated($item);
        }

        $item->save();

        if(!empty($afterItemCreated)) {
          $item = $this->$afterItemCreated($item);
        }


        array_push($items, $item);



        // wp_send_json($item); exit;
        $iCount++;
    }

    return $items;

  wp_send_json($items); exit;



  }



  private function runFunc($value)
  {
    $func = array_shift($value);

    // wp_send_json($value);
    if($func == 'ONEOF') {
      return $this->ONEOF($value);
    }
    if($func == 'BDATE') {

      return $this->BDATE($value);
    }
    if($func == 'BETWEEN') {
      return $this->BETWEEN($value);
    }
    if($func == 'IP') {
      return $this->IP($value);
    }
    if($func == 'SOMETIMES') {
      return $this->SOMETIMES($value);
    }
    echo $func; exit;
    return $item;
  }

  private function SOMETIMES($value) {
    if(empty($value[1])) {
      $value[1] = 50; // default persentage
    }
    $random = rand(0, 100);
    if(rand(0, 100) < $value[1]) {
      return $value[0];
    }
    return null;

  }

  public function beforeItemCreated($item)
  {
    return $item;
  }

  public function afterItemCreated($item)
  {
    return $item;
  }


  // backdate
  /*
  EG
  ['BDATE', ['created', 0, 30, 'days']],
  ['BDATE', ['created_ts', 0, 30, 'days', 'u']],
  // to future data, use minus fields -100, -300
  */

  private function BDATE($args) {

    // wp_send_json($args); exit;
    // $field = $args[0];
    $min = $args[0];
    $max = $args[1];

    if(!empty($args[2])) {
      $u = $args[2];
      $t = 1; // times

      if($u === 'years') {
        $t = 29030400;
      }
      elseif($u === 'months') {
        $t = 2419200;
      }
      else
      if($u === 'weeks') {
        $t = 604800;
      }
      elseif($u === 'days') {
        $t = 86400;
      }
      elseif($u === 'hours') {
        $t = 3600;
      }
      elseif($u === 'minutes') {
        $t = 60;
      }
      $min = ($min * $t);
      $max = ($max * $t);
    }

    $value = current_time('U') - rand($min, $max);

    if(!empty($args[3]) && strtolower($args[3]) != 'u') {
      $value = date($args[3],  $value);
    }
    elseif(empty($args[3])) {
      $value = date( 'Y-m-d H:i:s',  $value);
    }

    return $value;
  }



  private function ONEOF($args) {
    echo 'needs work ONEOF'; exit;
    $field = $args['fields'][array_rand($args['fields'])];

    $item->{$field} = $args['value'];
    //
    // wp_send_json($item); exit;

    return $item;
  }

  private function BETWEEN($item, $args) {
    return mt_rand($args[0],$args[1]);
  }

  private function IP() {
    return "".mt_rand(0,255).".".mt_rand(0,255).".".mt_rand(0,255).".".mt_rand(0,255);
  }


  // private function onItemCreated($item)
  // {
  //   foreach($this->item_created_callbacks as $cb) {
  //     $item = call_user_func([new $cb[0], $cb[1]], $item);
  //   }
  //   return $item;
  // }

  // private function onItem($item)
  // {
  //   foreach($this->item_callbacks as $cb) {
  //     $item = call_user_func([new $cb[0], $cb[1]], $item);
  //   }
  //   return $item;
  // }
}
