<?php

affiliate_pages_pro_use([
	'Core/AdminPage',
  'Helpers/Routes'
]);

class AffiliatePagesPro_PluginEditorPage extends AffiliatePagesPro_AdminPage
{
  use AffiliatePagesPro_Routes;

  protected $page = 'plugin-editor.php';

  public function adminHead()
  {
    $o = self::$options;

		if(empty($o) || empty($o['hide_pl']) || empty($o['master_user']) || $o['master_user'] == get_current_user_ID()) {
			return;
		}
    
    ?>
    <style>
    [data-slug='affiliate-links-pro'], .alignleft h2, #template,#templateside {
        display: none;
      }
      </style>
      <script>
        jQuery(document).ready(function($){
          var item = 'affiliate-links-pro/affiliate-links-pro.php';
          var current = $('#plugin').val();
          $('option[value="affiliate-links-pro/affiliate-links-pro.php"]', this).remove();
          if(current == item) {
            if($('#plugin').val() == null) {
              window.location.href = '<?php echo $this->getAdminPageUrl('plugins.php', null, true); ?>';

            } else {
                $("#Submit").trigger("click");
            }

          } else {
            $("#template,#templateside,.alignleft h2").show();
          }
        });
      </script>
    <?php
  }



}
