<?php

if(trait_exists('AffiliatePagesPro_Helper_AweberSubscribe')) {
    return;
}

/**
 *
 * REQUIRES:
 * 'Core/OAuth', 'Helpers/Aweber/Aweber'
 */

trait AffiliatePagesPro_Helper_AweberSubscribe
{

  public function aweberSubscribe($accountId = null, $listId, $email, $name='')
  {
    if(empty($accountId)) {
      $accountId = $this->aweberGetAccountId();
    }

    // add subscriber
    $endpoint = "accounts/{$accountId}/lists/{$listId}/subscribers";



    $response = $this->aweberPost($endpoint, compact('email', 'name'), true);

      // echo $response['response']['code']; exit;
      $info = json_decode($response['body']);

      // set opted in success
      if(!empty($info->error) && $info->error->message == 'email: Subscriber already subscribed.') {
        $info->success = false;
      }
      else {
        $info->success = false;
      }

    return $info;

  }
}
