<?php

if(trait_exists('AffiliatePagesPro_Collections')) {
    return;
}

trait AffiliatePagesPro_Collections
{

  public function toList($items, $fields = ['id' => 'id', 'name' => 'name'])
  {
    $list = [];

    foreach($items as $item) {
      $entry = [];
      foreach($fields as $key => $value) {
        if(is_object($item)) {
          $entry[$value] = $item->{$key};
        } else {
          $entry[$value] = $item[$key];
        }

      }
      array_push($list, $entry);
    }

    return $list;
  }

}
