<?php

trait AffiliatePagesPro_Color
{

	public function colorBasePalette($custom=false, $append=[]) {

		$palette = [
			['text' => 'Black', 'value' => 'black', 'color' => '#000000'],
			['text' => 'Dark', 'value' => 'dark', 'color' => '#333333'],
			['text' => 'Light', 'value' => 'light', 'color' => '#f2f2f2'],
			['text' => 'White', 'value' => 'white', 'color' => '#ffffff']
		];
		if(!empty($append)) {
			$palette = array_merge($palette, $append);
		}
		if(!empty($custom)) {
			array_push($palette, ['text' => 'Custom', 'value' => 'custom']);
		}
		return $palette;
	}

	public function colorPalette($custom=false, $append=[]) {

		$palette = [
			['text' => 'Excitement (red)', 'value' => 'excitement', 'color' => '#e61d2b'],
			['text' => 'Creative (purple)', 'value' => 'creative', 'color' => '#4003b0'],
			['text' => 'Friendly (orange)', 'value' => 'friendly', 'color' => '#ff9000'],
			['text' => 'Neutral (gray)', 'value' => 'neutral', 'color' => '#acacac'],
			// ['text' => 'Optimism ()', 'value' => 'optimism', 'color' => '#f6eb16'],
			['text' => 'Paceful (green)', 'value' => 'paceful', 'color' => '#009900'],
			['text' => 'Trust (blue)', 'value' => 'trust', 'color' => '#0270ba'],
		];
		if(!empty($append)) {
			$palette = array_merge($palette, $append);
		}
		if(!empty($custom)) {
			array_push($palette, ['text' => 'Custom', 'value' => 'custom']);
		}
		return $palette;
	}

}