<?php

if(trait_exists('AffiliatePagesPro_DripFeed')) {
    return;
}

/*
// include

 */


trait AffiliatePagesPro_DripFeed
{

	public function dripGetWeekDays()
	{
		return ['sunday', 'monday', 'tuesday', 'wednesday','thursday','friday', 'saturday'];
	}

	public function dripGetSecondsCount($u, $times = 1) {
		$units = ['seconds' => 1, 'minutes' => 60, 'hourly' => 3600, 'daily' => 86400, 'weekly' => 604800, 'monthly' => 2628000, 'yearly' => 31536000];

		return ($times*$units[$u]);
	}

	// monday, 45678654, true/false
 	public function dripWeekDayStartGetElapsed($weekDay, $regTs, $sameDayAccess = false) {

 		$regTs = (int) $regTs;

 		$ts = (int) current_time('timestamp');

 		// testing

 		$ewd = date('w', $regTs);

		$swd = array_search($weekDay, $this->dripGetWeekDays(), true);

		if($ewd >= $swd) {
			$waitDays = (7-$ewd) + $swd;
		} else {
			$waitDays = $swd - $ewd;
		}

		$wait = $waitDays * 86400;

		$opensTs = (int) ($wait + $regTs); 

		return (int)($ts - $opensTs);
 	}

	// monday, 45678654, true/false
 	public function dripMonthDayStartGetElapsed($monthDay, $regTs, $sameDayAccess = false) {

 		$regTs = (int) $regTs;

 		$ts = (int) current_time('timestamp');

 		$md = (int) $monthDay;
 		// testing

 		// $ewd = date('j', $regTs);

 		// echo $ewd.' '.$monthDay; exit;

		$ewd = date('j', $regTs);

		// echo $ewd; exit;
		// $ewd = 12;

		if($ewd >= $swd) {
			$waitDays = (date('t')-$ewd) + $swd;
		} else {
			$waitDays = $swd - $ewd;
		}

		// echo $waitDays; exit;

		$wait = $waitDays * 86400;

		$opensTs = (int) ($wait + $regTs); 

		return (int)($ts - $opensTs);
 	}
}