<?php

class AffiliatePagesPro_HtmlTag
{
  public static function div($id, $class='', $data=null) {
    echo '<div id="'.$id.'"';
    if(!empty($class)) {
      echo ' class="'.$class.'"';
    }
    if(!empty($data)) {
      self::data($data);
    }
    echo '</div>';
  }

  public static function data($tags=[])
  {
    if(!is_array($tags)) {
      $tags = [$tags];
    }

    foreach($tags as $key => $value) {
      echo ' data-'.$key.'="'.$value.'"';
    }
  }

  public static function css($styles)
  {
    affiliate_pages_pro_embed_css($styles);
  }

  public static function js($scripts)
  {
    affiliate_pages_pro_embed_js($scripts);
  }
}
