<?php

if(trait_exists('AffiliatePagesPro_ParseNumbers')) {
    return;
}

/*
parse single objects, array and items for numbers and true false

*/

trait AffiliatePagesPro_ParseNumbers
{

  public function parseItemNumbers($item)
  {
    if(is_object($item)) {
      return $this->parseObjectNumbers($item);
    }
    elseif(is_array($item)) {
      return $this->parseArrayNumbers($item);
    }
    elseif(is_numeric($item)) {
      return (int) $item;
    }
    elseif($item == 'true') {
      return true;
    }
    elseif($item == 'false') {
      return false;
    }
    return $item;
  }

  public function parseObjectNumbers($item)
    {
      foreach($item as $key => $value) {
        if(is_numeric($value)) {
          $item->{$key} = (int) $value;
        }
        elseif($value == 'true') {
          $item->{$key} = true;
        }
        elseif($value == 'false') {
          $item->{$key} = false;
        }
      }
      return $item;
    }

    public function parseArrayNumbers($item)
      {
        foreach($item as $key => $value) {
          if(is_numeric($value)) {
            $item[$key] = (int) $value;
          }
          elseif($value == 'true') {
            $item[$key] = true;
          }
          elseif($value == 'false') {
            $item[$key] = false;
          }
        }
        return $item;
      }
}
