<?php

if(trait_exists('AffiliatePagesPro_PostActions')) {
    return;
}

trait AffiliatePagesPro_PostActions
{
	public function postActions($redirect_to=null) 
	{
		// process post actions (usually in admin)
		if(!empty($_POST[self::$plugin_app_id.'_post_action'])) {
			$action = $_POST[self::$plugin_app_id.'_post_action'];

			/**
			 * updates a single group of options and will replace any previous values
			 * @var [type]
			 */
			if($action === 'update_option') {
				$option = $_POST['option'];
				$this->updateOption($option, $_POST[$option]);
			}

			/**
			 * Updates options fields and can update individual fields without remvoing other fields
			 * @var [type]
			 */
			if($action === 'update_option_fields') {
				$option = $_POST['option'];
				
				$values = $this->getOption($option, false);

				if(!is_array($values)) {
					$values = [];
				} 

				foreach($_POST as $key => $value) {
					if(!in_array($key, [self::$plugin_app_id.'_post_action', 'option'])) {
						$values[$key] = $value;
					}
				}

				// wp_send_json($values); exit;

				$this->updateOption($option, $values);
			}

			if(!empty($redirect_to)) {
				wp_redirect($redirect_to); exit;
			}
		}
	}
}