<?php

if(trait_exists('AffiliatePagesPro_ProductAddon')) {
    return;
}

/**
 * set protected $post_meta_key
 */

trait AffiliatePagesPro_ProductAddon
{
	/**
	 * prepends product name to product addon (used in lists)
	 * @param  [type] $addons   [description]
	 * @param  [type] $products [description]
	 * @return [type]           [description]
	 */
	public function addonPrependProductName($addons=null, $products=null)
	{
		if(empty($addons) || empty($products)) {
			return $addons;
		}
 
		// get product names
		$names = [];

		foreach($products as $prod) {
			$names['p_'.$prod->id] = $prod->name;
		}

		// append product names to addons
		$count=0;

		foreach($addons as $addon) {
			if(!empty($addon->product_id) && !empty($names['p_'.$addon->product_id])) {
				$addons{$count}->name = $names['p_'.$addon->product_id].': '.$addons{$count}->name; 
			}
			$count++;
		}

		return $addons;
	}


}