<?php

if(trait_exists('AffiliatePagesPro_UrlAppend')) {
    return;
}

trait AffiliatePagesPro_UrlAppend 
{
	public function urlAppendNoEncode($url, $args, $forward=false, $append='') {
		return $this->urlAppend($url, $args, $forward, $append, false);
	}

	public function urlAppend($url, $args, $forward=false, $append='', $doEncode=true) {
		
		if(!strstr($url, '?')) { $url .= '?'; } 
		else { $url = rtrim($url, '&').'&';}

		foreach ($args as $key => $value) {
			if(!empty($doEncode)) {
				$value = urlencode($value);
			}
			$url .= $key.'='.$value.'&';
		}
		
		$url = rtrim($url, '&');

		if(!empty($forward)) {
			wp_redirect($url.$append); exit;
		}
		return $url;
	}
}