<?php

if(trait_exists('AffiliatePagesPro_UserMeta')) {
    return;
}


trait AffiliatePagesPro_UserMeta
{
	// protected $user_meta_cach = [];
	public function getUserByMeta($key, $value) {
		$id = $this->getUserIdByMeta($key, $value);
		if(!empty($id)) {
			return get_user_by('ID', $id);
		}
		return null;
	}

	public function getUserIdByMeta($key, $value)
	{
		$key = $this->getUserMetaKey($key);

		global $wpdb;

		$query = "SELECT user_id FROM {$wpdb->usermeta} WHERE meta_key='{$key}' AND meta_value='{$value}' LIMIT 1";

		$result = $wpdb->get_row($query);

		if(!empty($result) && !empty($result->user_id)) {
			return $result->user_id;
		}
		return null;
	}

	public function getUserMeta($user_id, $key, $single=true, $prepKey=true) {

		if(!empty($prepKey)) {
			$key = $this->getUserMetaKey($key);
		}

		return get_user_meta($user_id, $key, $single);
	}

	public function updateUserMeta($user_id, $key, $value, $prepKey=true)
	{
		if(!empty($prepKey)) {
			$key = $this->getUserMetaKey($key);
		}

		return update_user_meta($user_id, $key, $value);
	}

	public function updateUserMetaValue($user_id, $name, $item, $value)
	{
		$update = $this->getUserMeta($user_id, $name);

		if(!empty($update) && is_object($update)) {
			$update->{$item} = $value;
		}
		else {
			$update[$field] = $value;
		}

		return $this->updateUserMeta($user_id, $name, $update);
	}

	public function deleteUserMeta($user_id, $name)
	{
		$key = $this->getUserMetaKey($name);
		return delete_user_meta($user_id, $key);
	}





	public function getUserMetaKey($name) {
		return self::$plugin_app_id.'_'.$name;
	}
}
