<?php

affiliate_pages_pro_use([
	'Core/Model',
	'Models/Stat'
	// 'Core/Time',
	// 'Models/Click',
	// 'Models/Tag'
]);


class AffiliatePagesPro_Split extends AffiliatePagesPro_Model
{

	protected $table = 'splits';

	protected $use_app_id = true;

	protected $filleble = [

		// 'id',
		'identifier',
		'user_id',
		'page_id',
		'block_id',

		'block_type',

		'content',

		'video',
		'is_video',
		'start',
		'end',
		'autoplay',
		'hide_controls', // 0: no, 1: yes, 2: muted
		'poster',// (0: autohide, 1: always, 2: never )
		'poster_pause',
		'poster_end',
		'duration',
		'trim_active',
		'product_placement',
		'muted',
		'product_img',
		'auto_redirect',
		'disable_fullscreen',
		'disable_mask',

		'url',
		'target',
		'is_dark',
		'color',
		'style',
		'item_style',
		'size',
		'item_link',

		'margin',
		'margin_x',
		'margin_y',
		'padding',
		'use_margin',
		'use_padding',
		'text_color',
		'shadow',
		'item_shadow',
		'bg_color',
		'bg_image',
		'source',

		'flex_xs',
		'flex_sm',
		'flex_md',
		'flex_lg',
		'align',

		'item_height',
		'item_width',
		'item_contain',
		'aspect_ratio',
		'custom_size',

		'item_timezone',
		'item_start',
		'item_startdate',
		'item_starttime',
		'item_startu',

		'border_radius',
		'title_color',
		'color2',
		'spacing_x',
		'spacing_y',

		'item_end',
		'item_enddate',
		'item_endtime',
		'item_endu',
		'hide_ended',
		'item_borderradius',
		'expanded',
		'show_more',
		'left_icon',
		'left_iconcolor',
		'right_icon',
		'right_iconcolor',
		'item_block'
	];

	public function onCreate() {
		$this->identifier = 'spli'.uniqid(true);
	}


}
