<?php

affiliate_pages_pro_use([
	'Core/Middleware',
	'Packages/Auth/Auth'
]);


class AffiliatePagesPro_ApiCheckAuth extends AffiliatePagesPro_Middleware
{

	public function handle($request)
	{
		if(empty($request->auth_token)) {
			$this->invalid();
		}

		// check if user is in token
		if(strstr($request->auth_token,'-') == true) {
			$part = explode('-', $request->auth_token);
			$request->auth_token = $part[0];
			$request->user_id = $part[1];
		}
		elseif(empty($request->user_id)) {
				$this->invalid();
		}

		if(empty($request->auth_token)) {
			$this->invalid();
		}

    $valid = AffiliatePagesPro_Auth::val($request->auth_token, $request->user_id);

		if(!$valid) {
			$this->invalid();
		}

		return true;
	}

	protected function invalid()
	{
		wp_send_json_error('Your session is invalid or has expired. Please try reload the page'); exit;
	}

}
