<?php


class AffiliatePagesPro_DB_Clicks extends AffiliatePagesPro_Migration
{
	protected $table = 'clicks';

	protected $use_group_id = false;

	public function up()
	{
		$this->increments('id')
		// ->string('identifier', 25)->unique()
		// ->integer('user_id', 13)->unsigned()->nullable() // created by
		->integer('page_id', 13)->unsigned()->nullable() // created by
		->integer('block_id', 13)->unsigned()->nullable() // created by
		->integer('visit_id', 13)->unsigned()->nullable()
		// ->string('client_ip', 200)->nullable() // if active to store
    ->integer('created_ts', 13)->nullable()
		->boolean('is_unique')->nullable()
		// ->boolean('is_conversion')->nullable()
    // ->integer('conversion_ts', 13)->nullable()

		->created()

		->create();

	}

	public function addColumns()
	{

		return [
			self::stringUpdate('client_ip', 25),
		];
	}

	public function down()
	{
		$this->dropIfExists();
	}
}
