<?php

if(empty($url)) {
  return;
}

if(empty($options)) {
  $options = self::$options;
  if(empty($options)) {
    $options = [];
  }
}

if(empty($options['fb_app_id'])) {
$options['fb_app_id'] = 190569694855224;
}
echo '<meta property="fb:app_id" content="'.trim($options['fb_app_id']).'" />';

$ogs = [
  'url' => $url.'/',
  'title' => !empty($page->og_title) ? stripslashes($page->og_title) : !empty($page->title) ? stripslashes($page->title) : '',
  'description' => !empty($page->og_des) ? stripslashes($page->og_des) : !empty($page->og_des) ? stripslashes($page->des) : '',
  'type' => !empty($page->og_type) ? stripslashes($page->og_type) : 'website',
];

foreach($ogs as $key => $value) {
  echo '<meta property="og:'.$key.'" content="'.htmlspecialchars($value).'" />';
}

if(empty($page->og_img)) {
  foreach(['image', 'bg_image'] as $i) {
    if(!empty($page->{$i})) {
      $page->og_img = $page->{$i};
      break;
    }
  }
}

if(!empty($page->og_img)) {

  echo '<meta property="og:image" content="'.$page->og_img.'" />';

  if(strstr($page->og_img,'s:') == true) {
    echo '<meta property="og:image:secure_url" content="'.$page->og_img.'" />';
  }

  if(empty($page->og_imgw)) {
    $page->og_imgw = 1280;
  }
  if(empty($page->og_imgh)) {
    $page->og_imgw = 720;
  }

  if(!empty($page->og_imgw)) {
      echo '<meta property="og:image:width" content="'.$page->og_imgw.'" />';
    }
    if(!empty($page->og_imgh)) {
      echo '<meta property="og:image:height" content="'.$page->og_imgh.'" />';
    }
}
