<?php

affiliate_pages_pro_use([
	'Controllers/Admin/AdminController',
	'Core/Plugin/PluginBuilder',
	'Helpers/Form',
]);

class AffiliatePagesPro_AdminHostController extends AffiliatePagesPro_AdminController
{
	use AffiliatePagesPro_Form, AffiliatePagesPro_Form;

	protected $id = 'host_branded_plugin';

	protected $access_level = 'activate_plugins';

	protected $view_container = 'foundation';

	public function __construct()
	{
        add_menu_page(
	        self::$plugin_app_name,
	       self::$plugin_app_name.' Business',
	        $this->access_level,
	        self::$plugin_app_cl.'-host',
	        [$this, 'host'],
	        'dashicons-businessman',
	        1
        );

        // TEST
        $plugin = [
        				'plugin_name' => 'Lead Machine',
        				'plugin_uri' => 'http://jamesbond-plugin.com',
        				'description' => 'Lead Machine helps you find leads',
        				'author' => 'James Bond',
        				'author_uri' => 'http://jamesbond.com',
        				'plugin' => 'wp-instant-leads',
        				'id' => 'pluginid123',
        				'version' => '1.0.0'
        			];

        $b = new AffiliatePagesPro_PluginBuild(self::$plugin_app_cl);

        $b->build($plugin);

        echo 'done'; exit;
	}

	public function host()
	{
		$this->form_url = $this->getAdminPageUrl();
		// echo $this->form_url; exit;
		$this->view('admin.host.index');
	}

	
}













