<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController',
	'Helpers/Client',
]);


class AffiliatePagesPro_ApiAppController extends AffiliatePagesPro_ApiController
{
	use AffiliatePagesPro_Client;

	public function index($request)
	{
		// wp_send_json([$request, self::$options['brand_user_id']]); exit;

		$lic = $this->getOption('lic');

		$lic['valid'] = $this->isLicValid($lic);

		// is_client
		$is_client = false;

		if(!empty(self::$options)
		&& !empty(self::$options['brand_user_id'])
		&& self::$options['brand_user_id'] != get_current_user_ID()
	) {
			$is_client = true;
		}

		$data = [
			'is_client' => $is_client,
			'valid_license' =>  $lic['valid'],
			// 'title' => 'CUSTOM TITLE',
			'data' => [
				'id' => self::$plugin_app_id,
				'title' => 'CUSTOM TITLE',//self::$plugin_app_name,
				'cl' => self::$plugin_app_cl,
			],
			'menus' => get_terms('nav_menu'),
			'lic' => $lic,
			'settings' => $this->getOption('settings'),
		];

		wp_send_json($data); exit;

	}

	private function isLicValid($lic)
	{
		foreach(['product', 'access', 'valid'] as $i) {
			if(empty($lic[$i])) {
				return false;
			}
			$lic = $lic[$i];
		}
		return $lic;
	}

}
