<?php

if(trait_exists('AffiliatePagesPro_DataTableDelete')) {
    return;
}

trait AffiliatePagesPro_DataTableDelete
{

  // filter
  public function onDestroy($item, $request)
  {
  }

  public function destroy($request)
  {

      $this->request = $request;

      if(!empty($this->use_db_user_id)) {

        $item = $this->builder->_where('id', $request->id)->andWhere('user_id', $request->user_id)->first(['id']);
      }
      else {
        $item = $this->builder->find($request->id, ['id']);
      }

      if(empty($item)) {
        wp_send_json_error('not found'); exit;
      }

      $this->onDestroy($item, $request);

      // remove

      if(!empty($item)) {
          $item->delete();
      }
      wp_send_json(['deleted'=>$request->id]);
  }


}
