<?php

if(trait_exists('AffiliatePagesPro_DataTableSlug')) {
    return;
}

trait AffiliatePagesPro_DataTableSlug
{

  // Datatable post from outside (returns next valid slug)
  public function checkSlug($request)
  {

    $slug = sanitize_title($request->slug);

    $query = $this->builder->_where('slug', $slug);

    // support non
    if(!empty($request->id)) {
      $query->andWhere('id', '!=', $request->id);
    }
    $exists = $query->first(['id']);

    if(empty($exists)) {
      wp_send_json_success($slug);
    }
    else {
      wp_send_json_error($this->getUniqueNext('slug', $slug, $request->id));
    }
    exit;
  }

}
