<?php

affiliate_pages_pro_use([
	'Helpers/StrGen',
	'Helpers/Options',
	'Helpers/Postman',
	'Helpers/Client',
	'Helpers/UrlAppend',
	'Helpers/RedirectTo'
]);

class AffiliatePagesPro_Deactivation extends AffiliatePagesPro
{
	use AffiliatePagesPro_StrGen,
		AffiliatePagesPro_Options,
		AffiliatePagesPro_Postman,
		AffiliatePagesPro_Client,
		AffiliatePagesPro_UrlAppend,
		AffiliatePagesPro_RedirectTo;

	protected $notify_host = true;

	public function __construct() 
	{
		if(!empty($this->notify_host)) {

			$client_access_key = $this->getOption('client_access_key');
			$data = [
				'client_access_key' => $client_access_key,
				'site_url' => get_site_url(),
				'app_id' => self::$plugin_app_id
			];

			$url = self::$plugin_app_host.'/api/client/deactivation';

			$this->notify($url, $data);
		}
		
		$this->deactivate();
	}

	public function deactivate() {}

}