<?php

/*
	18.9.18
	added orderby third argument option
*/

if(trait_exists('AffiliatePagesPro_ModelHasMany')) {
    return;
}

trait AffiliatePagesPro_ModelHasMany
{

	public function hasMany($related, $columns=null, $orderBy=null)
	{

		// to make it easy, just try do a model search, then add join
		$relatedName = AffiliatePagesPro::getPrefix().$related;

		$related = new $relatedName();

		$match_column = AffiliatePagesPro_Inflector::singularize($this->table).'_'.$this->primary_key;

		$related->query = " WHERE {$match_column} = '{$this->id}'";

    if(!empty($orderBy)) {
      $related->query_orderby = $orderBy;
    }


		$relatedTable = $related->getTableFullName();

		if(!$columns) {
			$related->query_columns = [$relatedTable.'.*'];
		}
		else {

			$related->query_columns = [];

			foreach($columns as $i) {
				array_push($related->query_columns, "{$relatedTable}.{$i}");
			}

		}

		$related->query_columns_set = true;

		return $related;

	}

}
