<?php

if(class_exists('AffiliatePagesPro_Stripe')) {
    return;
}

class AffiliatePagesPro_Stripe extends AffiliatePagesPro
{
	protected $pk;

	protected $sk;

	protected $post_url;

	protected $checkout_js = 'https://checkout.stripe.com/checkout.js';

	protected $checkout_class = 'stripe-button';

	protected $checkout = [
		'amount' => 999,
		'name' => 'Mastery Labs',
		'description' => '',
		'image' => 'https://stripe.com/img/documentation/checkout/marketplace.png',
		'locale' => 'auto',
		'currency' => 'aud'
	];



	public function getButton($args = [], $sk = '', $post_url='') 
	{
		if(empty($args)) {
			$args = $this->checkout;
		}
		if(empty($sk)) {
			$sk = $this->sk;
		}
		if(empty($post_url)) {
			$post_url = $this->post_url;
		}

		$btn = '<form action="'.$post_url.'" method="POST">';
		$btn .= '<script';
		$btn .= ' src="'.$this->checkout_js.'" class="'.$this->checkout_class.'"';
		$btn .= ' data-key="'.$sk.'"';
  
    	foreach($args as $key => $value) {
    		$btn .= ' data-'.$key.'="'.$sk.'"';
    	}

    	$btn .= '>';
    	$btn .= '</script>';
    	$btn .= '</form>';

    	return $btn;

	}
}