<?php

if(trait_exists('AffiliatePagesPro_Alerts')) {
    return;
}

trait AffiliatePagesPro_Alerts 
{

	protected $alerts;

	protected $alert_types = ['success', 'error', 'notice']; // success default

	public function showAlerts()
	{
		if(!empty($this->alerts)) {

			foreach ($this->alert_types as $type) {

				if(!empty($this->alerts[$type])) {

					foreach($this->alerts[$type] as $alert) {

						if($type === 'success') {
							$cl = 'updated';
						}
						else {
							$cl = $type;
						}

						echo '<div class="'.$cl.' notice is-dismissible"><p>'.$alert.'</p><button type="button" class="notice-dismiss"><span class="screen-reader-text">Dismiss this notice.</span></button></div>';
					}
				}
				
			}
		}
	}

	public function setAlert($msg, $type='success') {

		if(empty($this->alerts)) {
			$this->alerts = [];
		}
		if(empty($this->alerts[$type])) {
			$this->alerts[$type] = [$msg];
		}
		else {
			array_push($this->alerts[$type], $msg);
		}
	}

}