<?php

if(trait_exists('AffiliatePagesPro_SimpleAuth')) {
    return;
}

// uses session auth, secure admin area
trait AffiliatePagesPro_SimpleAuth
{


	public function doLogin($username, $password, $logUserIn=true) {

		if(strpos($username, '@')) {
			$user = get_user_by('email', trim(wp_unslash($username)));
			// $user = $userData->userLogin;

		}
		else {
			$user = get_user_by('login', trim($username));
		}

		if(empty($user) || empty($user->ID)) {
			return null;
		}

		$username = sanitize_user($user->user_login);
    	$password = trim($password);

    	$user = apply_filters( 'authenticate', null, $username, $password);
 
	    if ( $user == null ) {
	        return null;
	    }
	    else {
	 
		    $ignore_codes = array('empty_username', 'empty_password');
		 
		    if (is_wp_error($user) && !in_array($user->get_error_code(), $ignore_codes) ) {

		        return null;
		    }
		}

		if(!empty($logUserIn)) {
			// log user in
			$this->sessionStart();
			$this->setSession('user', $user->ID);
		}

		// login ok
		return $user;

	}

	public function isValidLogin($username, $password)
	{

	}


}