<?php

if(trait_exists('AffiliatePagesPro_Mailgun_Helpers')) {
    return;
}


trait AffiliatePagesPro_Mailgun_Helpers
{
	

	public function mailgunValidateCallback($request, $apiKey = false)
	{
		if(empty($apiKey)) {
			$apiKey = $this->getOptionValue('settings', 'mailgun_api_key');
		}
		
		if(empty($apiKey)) {
			return true;
		}

		if(empty($request->signature) || $request->signature != hash_hmac('sha256', $request->timestamp.$request->token, $apiKey)) {
			return false;
		}

		return true;

	}

}