<?php

if(trait_exists('AffiliatePagesPro_Nonce')) {
    return;
}

trait AffiliatePagesPro_Nonce
{
	public function nonceValid($id=null)
	{
		if(empty($id)) { $id = $this->id; }

		if(	empty($_POST) ||
			empty($_POST[$id.'_nonce']) ||
			!wp_verify_nonce($_POST[$id.'_nonce'], $id)
			) {
			return false;
		}

		return true;
	}

	public function nonceField($id=null)
	{
		if(empty($id)) { $id = $this->id; }
		echo '<input type="hidden" name="'.$id.'_nonce" value="'.wp_create_nonce($id).'">';
	}

}
