<?php


class AffiliatePagesPro_RemoveNull
{

  public static function parse($data)
  {
    if(empty($data)) {
      return $data;
    }

    if(is_object($data)) {
      return self::parseObject($data);
    }

    if(is_array($data)) {
      return self::parseArray($data);
    }

    exit;
  }



  private static function parseArray($data)
  {
    $items = []; $count = 0;

    foreach($data as $item) {

      if(is_object($item)) {
        array_push($items, self::parseObject($item));
      }
    }

    return $items;
  }

  private static function parseObject($item)
  {
    foreach($item as $key => $value) {
      if(is_null($value)) {
        unset($item->{$key});
      }
    }

    return $item;
  }
}
