<?php

if(trait_exists('AffiliatePagesPro_View')) {
    return;
}

trait AffiliatePagesPro_View
{


  public function components($path)
  {
    // require(plugin_dir_path(__FILE__).'components/'.$path.'.php');
    include(plugin_dir_path(__FILE__).'../../views/'.str_replace('.', '/', $path).'.php');
    // echo 'components';
  }



	public function viewTemplate($view, $args=null, $doExit=true, $is_module=null) {

		if(!empty($args)) {
			foreach ($args as $key => $value) {
				$$key = $value;
			}
		}

    if(!empty($this->class_wrapper)) {
      echo '<div class="'.$this->class_wrapper.'">';
    }

    if(!empty($this->custom_wrapper)) {
      echo $this->custom_wrapper[0];
    }

		if(!empty($is_module)) {
			include(plugin_dir_path(__FILE__).'../../modules/'.$is_module.'/views/'.str_replace('.', '/', $view).'.php');
		} else {
			include(plugin_dir_path(__FILE__).'../../views/'.str_replace('.', '/', $view).'.php');
		}

    if(!empty($this->class_wrapper)) {
      echo '</div>';
    }

    if(!empty($this->custom_wrapper)) {
      echo $this->custom_wrapper[1];
    }

		if(!empty($doExit)) {
			exit;
		}


	}

	public function viewJS($view,$args=null, $is_module=null) {
    header('Content-Type: application/javascript');

    if(!empty($args)) {
			foreach ($args as $key => $value) {
				$$key = $value;
			}
		}

    if(!empty($is_module)) {
			include(plugin_dir_path(__FILE__).'../../modules/'.$is_module.'/views/'.str_replace('.', '/', $view).'.php');
		} else {
			include(plugin_dir_path(__FILE__).'../../views/'.str_replace('.', '/', $view).'.php');
		}

  }


	public function view($view,$args=null, $is_module=null) {

		if(!empty($args)) {
			foreach ($args as $key => $value) {
				$$key = $value;
			}
		}

		if(!empty($this->is_module)) {
			$is_module = $this->is_module;
		}

		// style presets
		if(!empty($this->view_container)) {

			if($this->view_container == 'foundation') {

				$this->view_container = 'grid-container';

				$this->wrapper_class = true;

				$this->view_wrapper_shift = true;

				if(empty($this->view_styles)) {
					$this->view_styles = 'admin';
				}
			}

			elseif($this->view_container == 'bulma') {

				?>
				<style type="text/css">
					.ml-css .container p {
						font-size: 1rem;
					}
				</style>
				<?php
				$this->view_wrapper_shift = true;
				$this->view_container = 'container';
				affiliate_pages_pro_embed_css('https://cdnjs.cloudflare.com/ajax/libs/bulma/0.7.1/css/bulma.min.css');
				affiliate_pages_pro_embed_js('https://use.fontawesome.com/releases/v5.0.7/js/all.js');
			}
		}

		if(!empty($this->view_styles)) {
			affiliate_pages_pro_embed_css($this->view_styles);
		}

		if(!empty($this->view_scripts)) {
			affiliate_pages_pro_embed_js($this->view_scripts);
		}


		if(!empty($this->wrapper_class) && strlen($this->wrapper_class) < 2) {
			$this->wrapper_class = 'ml-css';
		}

		$this->viewOpenWrap();

		if(!empty($is_module)) {
			include(plugin_dir_path(__FILE__).'../../modules/'.$is_module.'/views/'.str_replace('.', '/', $view).'.php');
		} else {
			include(plugin_dir_path(__FILE__).'../../views/'.str_replace('.', '/', $view).'.php');
		}


		$this->viewCloseWrap();

		// scripts for footer
		if(!empty($this->view_footer_scripts)) {
			affiliate_pages_pro_embed_js($this->view_footer_scripts);
		}
	}

	public function viewOpenWrap()
	{
		if(!empty($this->wrapper_class)) {

			echo '<div class="'.$this->wrapper_class.'"';

			if(!empty($this->view_wrapper_shift)) {
				echo ' style="margin-left:-20px"';
			}
			echo '>';

			if(!empty($this->view_container)) {

				if(strlen($this->view_container) < 2) {
					$this->view_container = 'grid-container';
				}

				echo '<div class="'.$this->view_container.'">';
			}
		}
	}

	public function viewCloseWrap()
	{
		if(!empty($this->view_container)) {
			echo '</div>';
		}

		if(!empty($this->wrapper_class)) {
			echo '</div>';
		}
	}



	public function _link($url, $blank=true) {
		echo '<a href="'.$url.'"';
		if($blank) { echo '  target="_blank"'; }
		echo '>'.$url.'</a>';
	}

	/**
	 * @param  array(settings), string
	 * @param  string
	 * @param  trufalse not in use
	 * @return [type]
	 */
	public function _value($a=null, $b=null, $parse=null) {
		echo ' value="';
		$this->_echo($a, $b, $parse);
		echo '"';
	}

	public function _textarea($a=null, $b=null) {
		if($b) {
			// array
			if(!empty($a) && !empty($a[$b])) {
				echo stripslashes($a[$b]);
			}
		}

		else {
			if(!empty($a)) {
				echo stripslashes($a);
			}
		}
	}

	public function _echo($a=null, $b=null, $parse=null) {

		if($b) {
			// array
			if(!empty($a) && !empty($a[$b])) {
				echo $a[$b];
			}
		}

		else {
			if(!empty($a)) {
				echo $a;
			}
		}

	}
}
