<?php

affiliate_pages_pro_use([
	'Core/Middleware',
	'Packages/Auth/Auth'
]);

// returns true or false (for api use ApiCheckAuth)
class AffiliatePagesPro_CheckAuth extends AffiliatePagesPro_Middleware
{

	public function handle($request)
	{
		// check if user is in token
		if(strstr($request->auth_token,'-') == true) {
			$part = explode('-', $request->auth_token);
			$request->auth_token = $part[0];
			$request->user_id = $part[1];
		}
		elseif(empty($request->user_id)) {
			return false;
		}

    return AffiliatePagesPro_Auth::val($request->auth_token, $request->user_id);

	}
}
