<?php


class AffiliatePagesPro_DB_Stats extends AffiliatePagesPro_Migration
{
	protected $table = 'stats';

	protected $use_group_id = false;

	public function up()
	{
			$this->increments('id')
			->integer('visit_id', 13)->unsigned()->nullable()
			->integer('page_id', 13)->unsigned()->nullable()
			->integer('block_id', 13)->unsigned()->nullable()
			->integer('split_id', 13)->unsigned()->nullable()
			->boolean('is_visit')->nullable()
			->boolean('is_click')->nullable()
			->boolean('is_conversion')->nullable()
			->boolean('is_unique')->nullable()
	    ->integer('created_ts', 13)->nullable()
	    ->integer('click_ts', 13)->nullable()
	    ->integer('conversion_ts', 13)->nullable()
			->created()
			->create();

	}

	public function down()
	{
		$this->dropIfExists();
	}
}
