<?php


class AffiliatePagesPro_DB_Visits extends AffiliatePagesPro_Migration
{
	protected $table = 'visits';

	protected $use_group_id = false;

	public function up()
	{
		$this->increments('id')
		->string('identifier', 25)->unique()
		->integer('page_id', 13)->unsigned()->nullable() // created by
		->integer('block_id', 13)->unsigned()->nullable() // created by
		->string('client_ip', 200)->nullable() // if active to store
    ->integer('created_ts', 13)->nullable()
		->boolean('is_unique')->nullable()
		->boolean('is_conversion')->nullable()
    ->integer('conversion_ts', 13)->nullable()
		->boolean('clicked')->nullable()
		->created()

		->create();

	}

	public function addColumns()
	{

		// return [
		// 	self::textUpdate('description', 255),
		// ];
	}

	public function down()
	{
		$this->dropIfExists();
	}
}
