<?php

AffiliatePagesPro_Route::post('/api/host', 'Api/Host/ApiHostController@index');




// Admin
AffiliatePagesPro_Route::get('/api/settings', 'Api/Settings/ApiSettingsController@index', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/settings', 'Api/Settings/ApiSettingsController@update', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/settings/branding', 'Api/Settings/Branding/ApiSettingsBrandingController@update', 'Packages/Auth/ApiCheckAuth');

// admin lic
AffiliatePagesPro_Route::get('/api/lic', 'Api/Lic/ApiLicController@index', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/lic', 'Api/Lic/ApiLicController@update', 'Packages/Auth/ApiCheckAuth');


// advanced
// AffiliatePagesPro_Route::post('/api/advanced', 'Api/Advanced/ApiAdvancedController@index', 'Packages/Auth/ApiCheckAuth');




// Admin v2
AffiliatePagesPro_Route::get('/api/admin', 'Api/Admin/ApiAdminController@index', 'Packages/Auth/ApiCheckAuth');
AffiliatePagesPro_Route::get('/api/admin/menu/{menu}', 'Api/Admin/ApiAdminController@menu', 'Packages/Auth/ApiCheckAuth');

// Datatabse
AffiliatePagesPro_Route::dataTable('pages', '', 'Packages/Auth/ApiCheckAuth');
AffiliatePagesPro_Route::dataTable('blocks', '', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::get('/api/pages/{id}/blocks', 'Api/Page/Blocks/ApiPageBlocksController@index', 'Packages/Auth/ApiCheckAuth');
// AffiliatePagesPro_Route::post('/api/pages/{id}/builder', 'Api/Pages/Builder/ApiPagesBuilderController@update', 'Packages/Auth/ApiCheckAuth');
// AffiliatePagesPro_Route::dataTable('videos', '', 'Packages/Auth/ApiCheckAuth');
// AffiliatePagesPro_Route::dataTable('bonuses', 'Bonus', 'Packages/Auth/ApiCheckAuth');


AffiliatePagesPro_Route::get('/api/app', 'Api/App/ApiAppController@index', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/pages/{id}/reset-visits', 'Api/Visits/ApiVisitsController@reset', 'Packages/Auth/ApiCheckAuth');


// Visits
AffiliatePagesPro_Route::get('/api/visits', 'Api/Page/Visits/ApiPageVisitsAllController@index', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/visits/reset', 'Api/Page/Visits/ApiPageVisitsAllController@onReset', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::get('/api/pages/{id}/visits', 'Api/Page/Visits/ApiPageVisitsController@index', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::post('/api/pages/{id}/visits/reset', 'Api/Page/Visits/ApiPageVisitsController@onReset', 'Packages/Auth/ApiCheckAuth');



// split

AffiliatePagesPro_Route::dataTable('splits', '', 'Packages/Auth/ApiCheckAuth');

AffiliatePagesPro_Route::get('/api/blocks/{id}/splits', 'Api/Block/Split/ApiBlockSplitController@index', 'Packages/Auth/ApiCheckAuth');

// create first
AffiliatePagesPro_Route::post('/api/blocks/{block_id}/splits', 'Api/Block/Split/ApiBlockSplitController@create', 'Packages/Auth/ApiCheckAuth');

// dublicate a split
AffiliatePagesPro_Route::post('/api/blocks/{block_id}/splits/dub', 'Api/Block/Split/ApiBlockSplitController@dublicate', 'Packages/Auth/ApiCheckAuth');

// split results
AffiliatePagesPro_Route::get('/api/blocks/{id}/split-results', 'Api/Block/Split/ApiBlockSplitResultsController@index', 'Packages/Auth/ApiCheckAuth');
AffiliatePagesPro_Route::post('/api/blocks/{id}/split-results/reset', 'Api/Block/Split/ApiBlockSplitResultsController@destroy', 'Packages/Auth/ApiCheckAuth');



// LIVE
if(empty(AffiliatePagesPro::$options) || AffiliatePagesPro::$options['prefix'] === '') {

  AffiliatePagesPro_Route::getRoot('/api/{page}/{visit}', 'Api/Page/ApiPageController@index', null, null, true);

  AffiliatePagesPro_Route::getRoot('/api/{page}/{visit}/preview', 'Api/Page/ApiPageController@preview', null, null, true);

}
else {
  AffiliatePagesPro_Route::get('/:prefix/api/{page}/{visit}', 'Api/Page/ApiPageController@index', null, null, true);

    AffiliatePagesPro_Route::get('/:prefix/api/{page}/{visit}/preview', 'Api/Page/ApiPageController@preview', null, null, true);
}
